unit Unit1;

//EXEMPLE POUR LANCER OU RECUPERER LA FENETRE D'UNE APLICATION}
// Cet exemple montre comment executer un programme ou rcuprer la fenetre handle
// si celui-ci est dj lanc execut.

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  // Rajouter ces deux unites  la clause USES
  TLHelp32, ShellAPI;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'C:\Program Files\Microsoft Office\Office\Winword.exe';
end;

// RENVOIE L'ID DU PROCESS
//------------------------
Function ExeRunning (NomApplication : string) : Cardinal;
var ProcListExec : TProcessentry32;
    PrhListExec : Thandle;
    Flag : Boolean;
begin
  Result := 0;
  // on definit la taille du processus
  ProcListExec.dwSize:=sizeof(ProcListExec);
  Try
    // on prend une photo des processus en cours
    PrhListExec := CreateToolhelp32Snapshot(TH32CS_SNAPALL,0);
    if (PrhListExec <> INVALID_HANDLE_VALUE) then
      begin
        Flag := True;
        // on liste les process  la maniere d'un FINDFIRST}
        Process32First(PrhListExec,ProcListExec);
        while Flag = True do
          begin
            //on compare le nom des deux executable, si c'est les mme on a trouv le numro du processus
            if (Uppercase(ExtractFileName(ProcListExec.szExeFile)) = Uppercase(ExtractFileName (NomApplication))) then
              Begin
                Result := ProcListExec.th32ProcessID;
                Flag := False;
              end
            else Flag := Process32Next(PrhListExec,ProcListExec);
          end;
      end;
  Finally
    CloseHandle(PrhListExec);
  end;
end;

// ENUMERATION DES FENETRES PAR RAPPORT AU PROCESS
function EnumByProcess(handeul : HWND; lParam : Cardinal): boolean; stdcall;
var pPid : LPDWord;
begin
  if handeul <> 0 then
    begin
      // On recupere le numero de process d'apres le handle que nous renvoie ENUMWINDOWS
      GetWindowThreadProcessId(handeul,pPid);
      // Si les deux numero de processus coincide
      if pPid^ = LParam then
        // Et si la fenetre PEUT etre visible par l'utilisateur alors on l'affiche
        if IsWindowVisible (handeul) then ShowWindow (Handeul, SW_RESTORE);
      result := true;
    end
  else Result := False
end;

procedure TForm1.Button1Click(Sender: TObject);
Var ExecTmp : Array[0..254] of Char;
    Executable : PChar;
    IdProcess : Cardinal;
begin
  FillChar (ExecTmp, SizeOf (ExecTmp),0);
  IdProcess := ExeRunning (Edit1.Text);
  if IdProcess = 0 then
    Begin
      StrPLCopy(ExecTmp,Edit1.Text,Length (TRIM(Edit1.Text)));
      Executable := @ExecTmp;
      // Cet exemple n'utilise que des programmes sans parametre et sans
      // rpertoire de travail specifique
      ShellExecute (Handle,'open',Executable, Nil, Nil,SW_SHOWMAXIMIZED);
    End
  else EnumWindows(@EnumByProcess,IdProcess);
end;

end.
